# 
#     26 Oct 96   for da adopted from charissa version
#    8 jan 98   modified for use with F2VB module

#    This is the generic FERA system

set VERSION "F2VB"

loadsource  sys.common

set frametitle "MIDAS Data Acquisition System Control (FERA)"

set CAMACPresent 1
set CAMACEnable 1

set VMEPresent 1
set VMEEnable 1

set TSEnable 1

set histEnable 1
set HistMode 0

set txEnable 1

set DAProgram FERAExecV15

lappend actionlist [list "Raw VME Data Display"  "Dump_Raw_VME_Data"]

set TestBuffer "80010000  0fff0080  01000180  02000010  00200030  00400000  00000000  03000070  ffff8000"


proc Setup_Rdout {} {
   global EGreport Options
   global Supported_Modules

   set-footer "Defining hardware"
   set-busy

   set EGreport_SAVE $EGreport
   set EGreport -1

   ClearConfig

#    first we define FERA data modules

   set datalist [inform camaccontrol inquire datalist]
   foreach item $datalist {
       set moduletype [first $item]
       set module [second $item]
       set vsn [fifth $item]
       switch $moduletype {
           {Silena 4418/T}   -
           {Silena 4418/V}  {define_silena_module $module $vsn}
           {LeCroy 4300}    {define_lecroy_module $module $vsn}
           {Ortec 413}      {define_ortec_module $module $vsn}
           {FR48REG}        {define_fr48reg_module $module $vsn}
           {C1011}          {define_C1011_module $module $vsn}
           {Ortec HM413}    {define_hm_module $module $vsn}
           default          {insert-log "No definition for $module"}
       }
   }

#    then we define VME data modules

   foreach module $Supported_Modules {
       if {$Options(Include.$module) == 1} then {define_[set module]_config}
   }

   set EGreport $EGreport_SAVE

   clear-busy
   set-footer "All hardware defined"
}

proc create_spectra {} {
   global SpectrumServer HistMode EGreport Options
   global Supported_Modules

   if {$HistMode == 0} {return}

   set-footer "Creating spectra"
   set-busy

   set EGreport_SAVE $EGreport
   set EGreport -1

   Make_Xlate $SpectrumServer

   set range $Options(Stat.channels)
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Stat' !new)" } m]
   map_spectrum "Stat 0 0"

   set range $Options(Rate.channels)
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Rate' !new)" } m]

#    first we define FERA data modules and create spectra

   set datalist [inform camaccontrol inquire datalist]
   foreach item $datalist {
       set moduletype [first $item]
       set module [second $item]
       set vsn [fifth $item]
       switch $moduletype {
           {Silena 4418/T}   -
           {Silena 4418/V}  {create_silena_spectra $module $vsn}
           {LeCroy 4300}    {create_lecroy_spectra $module $vsn}
           {Ortec 413}      {create_ortec_spectra $module $vsn}
           {FR48REG}        {create_fr48reg_spectra $module $vsn}
           {C1011}          {create_C1011_spectra $module $vsn}
           {Ortec HM413}    {create_hm_spectra $module $vsn}
           default          {insert-log "No spectra created for $module"}
       }
   }

#    then we add VME data modules

   foreach module $Supported_Modules {
       if {$Options(Include.$module) == 1 &&  $Options(Histogram.$module) == 1} then {
           create_[set module]_spectra
       }
   }

   set EGreport $EGreport_SAVE

   clear-busy
   set-footer "Spectra created and mapped"
}


loadsource sys.fera
